diff --git a/doc/APIchanges b/doc/APIchanges
index 52b42762ea..3531596a7f 100644
--- a/doc/APIchanges
+++ b/doc/APIchanges
@@ -22,6 +22,9 @@ API changes, most recent first:
   av_fifo_grow2(), av_fifo_drain2(), av_fifo_write(), av_fifo_write_from_cb(),
   av_fifo_read(), av_fifo_read_to_cb(), av_fifo_peek(), av_fifo_peek_to_cb(),
   av_fifo_auto_grow_limit().
+  Deprecate av_fifo_alloc(), av_fifo_alloc_array(), av_fifo_size(), av_fifo_space(),
+  av_fifo_generic_peek(), av_fifo_generic_peek_at(), av_fifo_generic_read(),
+  av_fifo_generic_write(), av_fifo_realloc2(), av_fifo_grow(), av_fifo_drain().
 
 2022-01-xx - xxxxxxxxxx - lavu fifo.h
   Access to all AVFifoBuffer members is deprecated. The struct will
diff --git a/libavutil/fifo.c b/libavutil/fifo.c
index 2c15df5d5c..bd227d23e8 100644
--- a/libavutil/fifo.c
+++ b/libavutil/fifo.c
@@ -94,6 +94,8 @@ void av_fifo_auto_grow_limit(AVFifoBuffer *f, size_t max_elems)
     fb->auto_grow_limit = max_elems;
 }
 
+#if FF_API_FIFO_OLD_API
+FF_DISABLE_DEPRECATION_WARNINGS
 AVFifoBuffer *av_fifo_alloc_array(size_t nmemb, size_t size)
 {
     if (nmemb > SIZE_MAX / size)
@@ -105,6 +107,8 @@ AVFifoBuffer *av_fifo_alloc(unsigned int size)
 {
     return av_fifo_alloc_array(size, 1);
 }
+FF_ENABLE_DEPRECATION_WARNINGS
+#endif
 
 void av_fifo_free(AVFifoBuffer *f)
 {
@@ -155,6 +159,7 @@ size_t av_fifo_can_write(const AVFifoBuffer *f)
     return fb->nb_elems - av_fifo_can_read(f);
 }
 
+#if FF_API_FIFO_OLD_API
 int av_fifo_size(const AVFifoBuffer *f)
 {
     return av_fifo_can_read(f);
@@ -164,6 +169,7 @@ int av_fifo_space(const AVFifoBuffer *f)
 {
     return av_fifo_can_write(f);
 }
+#endif
 
 int av_fifo_grow2(AVFifoBuffer *f, size_t inc)
 {
@@ -370,6 +376,8 @@ int av_fifo_peek_to_cb(AVFifoBuffer *f, AVFifoCB write_cb, void *opaque,
     return fifo_peek_common(f, NULL, nb_elems, offset, write_cb, opaque);
 }
 
+#if FF_API_FIFO_OLD_API
+FF_DISABLE_DEPRECATION_WARNINGS
 int av_fifo_realloc2(AVFifoBuffer *f, unsigned int new_size)
 {
     FifoBuffer *fb = (FifoBuffer*)f;
@@ -528,3 +536,5 @@ void av_fifo_drain(AVFifoBuffer *f, int size)
 {
     return av_fifo_drain2(f, size);
 }
+FF_ENABLE_DEPRECATION_WARNINGS
+#endif
diff --git a/libavutil/fifo.h b/libavutil/fifo.h
index 11eb36944a..c2e11e11ab 100644
--- a/libavutil/fifo.h
+++ b/libavutil/fifo.h
@@ -62,6 +62,7 @@ AVFifoBuffer;
  */
 typedef int AVFifoCB(void *opaque, void *buf, size_t *nb_elems);
 
+#if FF_API_FIFO_OLD_API
 /**
  * Initialize an AVFifoBuffer.
  * @param size of FIFO
@@ -69,7 +70,9 @@ typedef int AVFifoCB(void *opaque, void *buf, size_t *nb_elems);
  *
  * @note the element size of the allocated FIFO will be 1, i.e. all operations
  *       will be in bytes
+ * @deprecated use av_fifo_alloc2
  */
+attribute_deprecated
 AVFifoBuffer *av_fifo_alloc(unsigned int size);
 
 /**
@@ -80,8 +83,11 @@ AVFifoBuffer *av_fifo_alloc(unsigned int size);
  *
  * @note the element size of the allocated FIFO will be 1, i.e. all operations
  *       will be in bytes
+ * @deprecated use av_fifo_alloc2
  */
+attribute_deprecated
 AVFifoBuffer *av_fifo_alloc_array(size_t nmemb, size_t size);
+#endif
 
 /**
  * Automatically resize the FIFO on writes, so that the data fits. This
@@ -134,12 +140,15 @@ void av_fifo_auto_grow_limit(AVFifoBuffer *f, size_t max_elems);
  */
 void av_fifo_reset(AVFifoBuffer *f);
 
+#if FF_API_FIFO_OLD_API
 /**
  * Return the amount of data in the AVFifoBuffer, that is the amount of data
  * (in elements, as returned by av_fifo_elem_size()) you can read from it.
  * @param f AVFifoBuffer to read from
  * @return size
+ * @deprecated use av_fifo_can_read()
  */
+attribute_deprecated
 int av_fifo_size(const AVFifoBuffer *f);
 
 /**
@@ -147,8 +156,11 @@ int av_fifo_size(const AVFifoBuffer *f);
  * (in elements, as returned by av_fifo_elem_size()) you can write into it.
  * @param f AVFifoBuffer to write into
  * @return size
+ * @deprecated use av_fifo_can_write()
  */
+attribute_deprecated
 int av_fifo_space(const AVFifoBuffer *f);
+#endif
 
 /**
  * @return number of elements available for reading from the given FIFO.
@@ -269,6 +281,7 @@ int av_fifo_peek_to_cb(AVFifoBuffer *f, AVFifoCB write_cb, void *opaque,
  */
 void av_fifo_drain2(AVFifoBuffer *f, size_t size);
 
+#if FF_API_FIFO_OLD_API
 /**
  * Feed data at specific position from an AVFifoBuffer to a user-supplied callback.
  * Similar as av_fifo_gereric_read but without discarding data.
@@ -279,7 +292,10 @@ void av_fifo_drain2(AVFifoBuffer *f, size_t size);
  * @param dest data destination
  *
  * @return a non-negative number on success, a negative error code on failure
+ *
+ * @deprecated use av_fifo_peek() when func==NULL, av_fifo_peek_to_cb() otherwise
  */
+attribute_deprecated
 int av_fifo_generic_peek_at(AVFifoBuffer *f, void *dest, int offset, int buf_size, void (*func)(void*, void*, int));
 
 /**
@@ -291,7 +307,10 @@ int av_fifo_generic_peek_at(AVFifoBuffer *f, void *dest, int offset, int buf_siz
  * @param dest data destination
  *
  * @return a non-negative number on success, a negative error code on failure
+ *
+ * @deprecated use av_fifo_peek() when func==NULL, av_fifo_peek_to_cb() otherwise
  */
+attribute_deprecated
 int av_fifo_generic_peek(AVFifoBuffer *f, void *dest, int buf_size, void (*func)(void*, void*, int));
 
 /**
@@ -302,7 +321,10 @@ int av_fifo_generic_peek(AVFifoBuffer *f, void *dest, int buf_size, void (*func)
  * @param dest data destination
  *
  * @return a non-negative number on success, a negative error code on failure
+ *
+ * @deprecated use av_fifo_read() when func==NULL, av_fifo_read_to_cb() otherwise
  */
+attribute_deprecated
 int av_fifo_generic_read(AVFifoBuffer *f, void *dest, int buf_size, void (*func)(void*, void*, int));
 
 /**
@@ -317,7 +339,10 @@ int av_fifo_generic_read(AVFifoBuffer *f, void *dest, int buf_size, void (*func)
  * indicate no more data available to write.
  * If func is NULL, src is interpreted as a simple byte array for source data.
  * @return the number of elements written to the FIFO or a negative error code on failure
+ *
+ * @deprecated use av_fifo_write() when func==NULL, av_fifo_write_to_cb() otherwise
  */
+attribute_deprecated
 int av_fifo_generic_write(AVFifoBuffer *f, void *src, int size, int (*func)(void*, void*, int));
 
 /**
@@ -327,7 +352,11 @@ int av_fifo_generic_write(AVFifoBuffer *f, void *src, int size, int (*func)(void
  * @param f AVFifoBuffer to resize
  * @param size new AVFifoBuffer size in elements
  * @return <0 for failure, >=0 otherwise
+ *
+ * @deprecated use av_fifo_grow2() to increase fifo size, decreasing fifo size
+ * is not supported
  */
+attribute_deprecated
 int av_fifo_realloc2(AVFifoBuffer *f, unsigned int size);
 
 /**
@@ -339,15 +368,23 @@ int av_fifo_realloc2(AVFifoBuffer *f, unsigned int size);
  * @param additional_space the amount of space in elements to allocate in
  *                         addition to av_fifo_size()
  * @return <0 for failure, >=0 otherwise
+ *
+ * @deprecated use av_fifo_grow2(); note that unlike this function it adds to
+ * allocated size, rather than to used size
  */
+attribute_deprecated
 int av_fifo_grow(AVFifoBuffer *f, unsigned int additional_space);
 
 /**
  * Read and discard the specified amount of data from an AVFifoBuffer.
  * @param f AVFifoBuffer to read from
  * @param size amount of data to read in elements
+ *
+ * @deprecated use av_fifo_drain2()
  */
+attribute_deprecated
 void av_fifo_drain(AVFifoBuffer *f, int size);
+#endif
 
 #if FF_API_FIFO_PEEK2
 /**
diff --git a/libavutil/version.h b/libavutil/version.h
index 180ebd5223..756318f495 100644
--- a/libavutil/version.h
+++ b/libavutil/version.h
@@ -111,6 +111,7 @@
 #define FF_API_AV_MALLOCZ_ARRAY         (LIBAVUTIL_VERSION_MAJOR < 58)
 #define FF_API_FIFO_PEEK2               (LIBAVUTIL_VERSION_MAJOR < 58)
 #define FF_API_FIFO_PUBLIC              (LIBAVUTIL_VERSION_MAJOR < 58)
+#define FF_API_FIFO_OLD_API             (LIBAVUTIL_VERSION_MAJOR < 58)
 
 /**
  * @}